Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
18 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
19 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
20 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
21 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
22 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
23 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
24 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
25 c3754a5b 2019-05-10 stsp
26 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
27 7b67836a 2019-05-10 stsp
28 f6cae3ed 2020-09-13 naddy git_init()
29 0e673013 2019-01-02 stsp {
30 0b2899f8 2019-08-18 stsp git init -q "$1"
31 0e673013 2019-01-02 stsp }
32 0e673013 2019-01-02 stsp
33 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
34 b32c4525 2020-01-05 stsp {
35 b32c4525 2020-01-05 stsp local repo="$1"
36 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
37 b32c4525 2020-01-05 stsp (cd $repo && git repack -a -q)
38 b32c4525 2020-01-05 stsp fi
39 b32c4525 2020-01-05 stsp }
40 b32c4525 2020-01-05 stsp
41 f6cae3ed 2020-09-13 naddy git_commit()
42 0e673013 2019-01-02 stsp {
43 0e673013 2019-01-02 stsp local repo="$1"
44 0e673013 2019-01-02 stsp shift
45 0b2899f8 2019-08-18 stsp (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
46 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
47 0e673013 2019-01-02 stsp }
48 0e673013 2019-01-02 stsp
49 f6cae3ed 2020-09-13 naddy git_rm()
50 512f0d0e 2019-01-02 stsp {
51 512f0d0e 2019-01-02 stsp local repo="$1"
52 512f0d0e 2019-01-02 stsp shift
53 512f0d0e 2019-01-02 stsp (cd $repo && git rm -q "$@")
54 512f0d0e 2019-01-02 stsp }
55 512f0d0e 2019-01-02 stsp
56 f6cae3ed 2020-09-13 naddy git_show_head()
57 9c4b8182 2019-01-02 stsp {
58 9c4b8182 2019-01-02 stsp local repo="$1"
59 9c4b8182 2019-01-02 stsp (cd $repo && git show --no-patch --pretty='format:%H')
60 9c4b8182 2019-01-02 stsp }
61 9c4b8182 2019-01-02 stsp
62 f6cae3ed 2020-09-13 naddy git_show_branch_head()
63 db32465d 2020-02-07 stsp {
64 db32465d 2020-02-07 stsp local repo="$1"
65 db32465d 2020-02-07 stsp local branch="$2"
66 db32465d 2020-02-07 stsp (cd $repo && git show --no-patch --pretty='format:%H' $branch)
67 db32465d 2020-02-07 stsp }
68 db32465d 2020-02-07 stsp
69 db32465d 2020-02-07 stsp
70 f6cae3ed 2020-09-13 naddy git_show_author_time()
71 bcb49d15 2019-08-14 stsp {
72 bcb49d15 2019-08-14 stsp local repo="$1"
73 01073a5d 2019-08-22 stsp local object="$2"
74 01073a5d 2019-08-22 stsp (cd $repo && git show --no-patch --pretty='format:%at' $object)
75 bcb49d15 2019-08-14 stsp }
76 bcb49d15 2019-08-14 stsp
77 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
78 8e7bd50a 2019-08-22 stsp {
79 8e7bd50a 2019-08-22 stsp local repo="$1"
80 8e7bd50a 2019-08-22 stsp local tag="$2"
81 8e7bd50a 2019-08-22 stsp (cd $repo && git cat-file tag $tag | grep ^tagger | \
82 8e7bd50a 2019-08-22 stsp sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
83 8e7bd50a 2019-08-22 stsp }
84 8e7bd50a 2019-08-22 stsp
85 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
86 818c7501 2019-07-11 stsp {
87 818c7501 2019-07-11 stsp local repo="$1"
88 70551d57 2020-04-24 stsp local commit="$2"
89 70551d57 2020-04-24 stsp (cd $repo && git show --no-patch --pretty='format:%P' $commit)
90 818c7501 2019-07-11 stsp }
91 818c7501 2019-07-11 stsp
92 f6cae3ed 2020-09-13 naddy git_show_tree()
93 03415a1a 2019-06-02 stsp {
94 03415a1a 2019-06-02 stsp local repo="$1"
95 03415a1a 2019-06-02 stsp (cd $repo && git show --no-patch --pretty='format:%T')
96 03415a1a 2019-06-02 stsp }
97 03415a1a 2019-06-02 stsp
98 f6cae3ed 2020-09-13 naddy trim_obj_id()
99 818c7501 2019-07-11 stsp {
100 9439a990 2020-09-16 naddy local trimcount=$1
101 9439a990 2020-09-16 naddy local id=$2
102 818c7501 2019-07-11 stsp
103 9439a990 2020-09-16 naddy local pat=""
104 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
105 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
106 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
107 818c7501 2019-07-11 stsp done
108 818c7501 2019-07-11 stsp
109 818c7501 2019-07-11 stsp echo ${id%$pat}
110 818c7501 2019-07-11 stsp }
111 818c7501 2019-07-11 stsp
112 f6cae3ed 2020-09-13 naddy git_commit_tree()
113 03415a1a 2019-06-02 stsp {
114 03415a1a 2019-06-02 stsp local repo="$1"
115 03415a1a 2019-06-02 stsp local msg="$2"
116 03415a1a 2019-06-02 stsp local tree="$3"
117 03415a1a 2019-06-02 stsp (cd $repo && git commit-tree -m "$msg" "$tree")
118 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
119 03415a1a 2019-06-02 stsp }
120 03415a1a 2019-06-02 stsp
121 f6cae3ed 2020-09-13 naddy make_test_tree()
122 0e673013 2019-01-02 stsp {
123 0e673013 2019-01-02 stsp repo="$1"
124 0e673013 2019-01-02 stsp
125 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
126 0e673013 2019-01-02 stsp echo beta > $repo/beta
127 0e673013 2019-01-02 stsp mkdir $repo/gamma
128 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
129 0e673013 2019-01-02 stsp mkdir $repo/epsilon
130 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
131 0e673013 2019-01-02 stsp }
132 0e673013 2019-01-02 stsp
133 f6cae3ed 2020-09-13 naddy make_single_file_repo()
134 e7303626 2020-05-14 stsp {
135 e7303626 2020-05-14 stsp repo="$1"
136 e7303626 2020-05-14 stsp file="$2"
137 e7303626 2020-05-14 stsp
138 e7303626 2020-05-14 stsp mkdir $repo
139 e7303626 2020-05-14 stsp git_init $repo
140 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
141 e7303626 2020-05-14 stsp (cd $repo && git add .)
142 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
143 e7303626 2020-05-14 stsp }
144 e7303626 2020-05-14 stsp
145 f6cae3ed 2020-09-13 naddy get_loose_object_path()
146 e7303626 2020-05-14 stsp {
147 e7303626 2020-05-14 stsp local repo="$1"
148 e7303626 2020-05-14 stsp local id="$2"
149 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
150 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
151 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
152 e7303626 2020-05-14 stsp }
153 e7303626 2020-05-14 stsp
154 f6cae3ed 2020-09-13 naddy get_blob_id()
155 3ce1b845 2019-07-15 stsp {
156 3ce1b845 2019-07-15 stsp repo="$1"
157 3ce1b845 2019-07-15 stsp tree_path="$2"
158 3ce1b845 2019-07-15 stsp filename="$3"
159 3ce1b845 2019-07-15 stsp
160 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
161 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
162 3ce1b845 2019-07-15 stsp }
163 3ce1b845 2019-07-15 stsp
164 f6cae3ed 2020-09-13 naddy test_init()
165 0e673013 2019-01-02 stsp {
166 0e673013 2019-01-02 stsp local testname="$1"
167 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
168 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
169 0e673013 2019-01-02 stsp echo "No test name provided" >&2
170 0e673013 2019-01-02 stsp return 1
171 0e673013 2019-01-02 stsp fi
172 e5a14fe3 2020-10-01 stsp local testroot=`mktemp -d "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXX"`
173 0e673013 2019-01-02 stsp mkdir $testroot/repo
174 0e673013 2019-01-02 stsp git_init $testroot/repo
175 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
176 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
177 3ce1b845 2019-07-15 stsp (cd $repo && git add .)
178 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
179 4a1ddfc2 2019-01-12 stsp fi
180 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
181 0e673013 2019-01-02 stsp echo "$testroot"
182 0e673013 2019-01-02 stsp }
183 0e673013 2019-01-02 stsp
184 f6cae3ed 2020-09-13 naddy test_cleanup()
185 0e673013 2019-01-02 stsp {
186 0e673013 2019-01-02 stsp local testroot="$1"
187 fe7842f5 2019-07-14 stsp
188 fe7842f5 2019-07-14 stsp (cd $testroot/repo && git fsck --strict \
189 fe7842f5 2019-07-14 stsp > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
190 fe7842f5 2019-07-14 stsp ret="$?"
191 fe7842f5 2019-07-14 stsp if [ "$ret" != "0" ]; then
192 fe7842f5 2019-07-14 stsp echo -n "git fsck: "
193 fe7842f5 2019-07-14 stsp cat $testroot/fsck.stderr
194 fe7842f5 2019-07-14 stsp echo "git fsck failed; leaving test data in $testroot"
195 fe7842f5 2019-07-14 stsp return 1
196 fe7842f5 2019-07-14 stsp fi
197 fe7842f5 2019-07-14 stsp
198 0e673013 2019-01-02 stsp rm -rf "$testroot"
199 0e673013 2019-01-02 stsp }
200 0e673013 2019-01-02 stsp
201 f6cae3ed 2020-09-13 naddy test_parseargs()
202 7fb414ae 2020-08-08 stsp {
203 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
204 6c8da0c6 2020-10-03 naddy case $flag in
205 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
206 6c8da0c6 2020-10-03 naddy ;;
207 6c8da0c6 2020-10-03 naddy r) export GOT_TEST_ROOT=$OPTARG
208 6c8da0c6 2020-10-03 naddy ;;
209 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
210 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
211 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
212 6c8da0c6 2020-10-03 naddy exit 2
213 6c8da0c6 2020-10-03 naddy ;;
214 7fb414ae 2020-08-08 stsp esac
215 7fb414ae 2020-08-08 stsp done
216 6c8da0c6 2020-10-03 naddy } >&2
217 7fb414ae 2020-08-08 stsp
218 f6cae3ed 2020-09-13 naddy run_test()
219 0e673013 2019-01-02 stsp {
220 0e673013 2019-01-02 stsp testfunc="$1"
221 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
222 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
223 7fb414ae 2020-08-08 stsp fi
224 0e673013 2019-01-02 stsp $testfunc
225 0e673013 2019-01-02 stsp }
226 0e673013 2019-01-02 stsp
227 f6cae3ed 2020-09-13 naddy test_done()
228 0e673013 2019-01-02 stsp {
229 0e673013 2019-01-02 stsp local testroot="$1"
230 0e673013 2019-01-02 stsp local result="$2"
231 0e673013 2019-01-02 stsp if [ "$result" == "0" ]; then
232 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
233 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
234 7fb414ae 2020-08-08 stsp echo "ok"
235 7fb414ae 2020-08-08 stsp fi
236 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
237 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
238 3941b73a 2019-05-14 stsp echo "$result"
239 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
240 0e673013 2019-01-02 stsp else
241 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
242 0e673013 2019-01-02 stsp fi
243 0e673013 2019-01-02 stsp }